#ifndef STARSFunction_h
#define STARSFunction_h

#include "interfaces/STARSTypes.h"

class SMPFunction;

class STARS_Function_t
{
	public:
		virtual ~STARS_Function_t() { };
		virtual char* GetFunctionName(char* name, const int len) const = 0;
		virtual STARS_ea_t get_startEA() = 0;
		virtual STARS_ea_t get_endEA() = 0;
		virtual std::size_t GetFuncSize() = 0;
		virtual std::size_t GetFrameSize() = 0;
		virtual void SetFrameSize(std::size_t size) = 0;
		virtual std::size_t GetSavedRegSize() = 0;
		virtual std::size_t GetIncomingArgumentSize() = 0;
		virtual std::size_t GetFrameReturnAddressSize() = 0;
		virtual bool IsInstIDInFunc(STARS_ea_t InstID) = 0;
		virtual bool FunctionUsesFP() = 0;
		virtual bool IsStaticFunction() = 0;
		virtual bool IsLibraryFunction() = 0;
		virtual bool IsStackPointerAnalyzed() = 0;
		virtual STARS_sval_t get_spd(STARS_ea_t ea) = 0;
		virtual bool HasReturnPoints() = 0;
		virtual bool IsMultiEntry(bool HasIndirectJumps) = 0;
		virtual void MarkSharedChunks() = 0;
		virtual bool HasSharedChunks() const = 0;
		virtual void SetSharedChunks(bool v) = 0;
		virtual void UpdateXrefs() = 0;
		virtual void BuildFuncIR(SMPFunction *func) = 0;
		virtual void FindFixedCalls(SMPFunction *CurrFunc) = 0;
		virtual bool FindDistantCodeFragment(SMPFunction* func, STARS_ea_t TargetAddr) = 0;
		virtual void FillInLocalVarTable(SMPFunction *CurrFunc) = 0; // get stack frame fine-grained info
		virtual bool AnalyzeInstAsCallTarget(SMPFunction *CurrFunc, bool &IsIndirectCallTarget, bool &IsTailCallTarget) = 0; // return success or failure of analysis
		virtual bool IsChunkUnshared(STARS_ea_t ChunkAddr, STARS_ea_t FuncHeadStart, STARS_ea_t FuncHeadEnd) = 0;

		virtual void Dump() { } ;

};

#endif
