#ifndef STARS_IRDB_Function_h
#define STARS_IRDB_Function_h

#include "interfaces/STARSTypes.h"
#include <libIRDB-core.hpp>

class SMPFunction;
class SMPInstr;

class STARS_IRDB_Function_t : public STARS_Function_t 
{
public:

	STARS_IRDB_Function_t(libIRDB::Function_t* f, libIRDB::FileIR_t* _firp) : the_func(f), firp(_firp)
	{ 
	}

	// obvious
	virtual char* GetFunctionName(char* name, const int len) const 
	{ strncpy((char*)name,the_func->GetName().c_str(),len); return (char*)name; }

	// get entry point of function
		virtual STARS_ea_t get_startEA() { return the_func->GetEntryPoint()->GetBaseID(); }

	// clc needs to review and get back to me.
		virtual STARS_ea_t get_endEA() { assert(0); }

	// return # of instructions.
	virtual std::size_t GetFuncSize() { return the_func->GetInstructions().size(); } 


#if 1
//This chunk of things is going away?
	// init class-local variable with IRDB value
	// and these are accessors to that.
	virtual std::size_t GetFrameSize(){ return the_func -> GetStackFrameSize(); }


	// should go away.
	virtual void SetFrameSize(std::size_t size) { assert(0); }

	// todo for clc: audit these functions and see if they are really getting info from idapro
	// or if these can be removed from the interface because they are calculated by STARS 
	// interface-independent routines.
	// eventually going away.


	virtual std::size_t GetSavedRegSize() 
	{ 

// tmp for debugging
return 0;
		std::size_t size=0;
		libIRDB::Instruction_t* insn=the_func->GetEntryPoint();
		while(insn && insn->GetTarget()==NULL)
		{
			DISASM d;
			insn->Disassemble(d);
			if(std::string(d.Instruction.Mnemonic)=="push")	
				size+=(firp->GetArchitectureBitWidth()/8);
			insn=insn->GetFallthrough();
		}

		return size;
	}
	virtual std::size_t GetIncomingArgumentSize() 
	{ 
// tmp for debugging
return 0;
		assert(0); 
	}
	virtual std::size_t GetFrameReturnAddressSize() 
	{ 
		std::size_t size=(std::size_t)firp->GetArchitectureBitWidth();
		size/=8;
		return size;
//		assert(0); 
	}
 

		virtual bool FunctionUsesFP(){ return the_func->GetUseFramePointer(); }
		virtual bool IsStaticFunction(){ return false; }
		virtual bool IsLibraryFunction(){ return false; }


		virtual bool IsStackPointerAnalyzed(){ return false; assert(0); }
	virtual STARS_sval_t get_spd(STARS_ea_t ea){ return 0; assert(0); }
	virtual bool HasReturnPoints(){ return true; assert(0); }
	virtual bool IsMultiEntry(bool HasIndirectJumps){ return false; assert(0); }
	virtual void MarkSharedChunks(){ return; assert(0); }
	virtual bool HasSharedChunks() const { return false; assert(0); }
	virtual void SetSharedChunks(bool v) { return; assert(0); }
		virtual void UpdateXrefs(){ return; assert(0); }
	virtual void FillInLocalVarTable(SMPFunction *CurrFunc) { return; assert(0); }
	virtual bool IsChunkUnshared(STARS_ea_t ChunkAddr, STARS_ea_t FuncHeadStart, STARS_ea_t FuncHeadEnd) { return true; assert(0); }
#endif

	virtual void BuildFuncIR(SMPFunction *func);

	virtual void FindFixedCalls(SMPFunction *CurrFunc);

		virtual bool FindDistantCodeFragment(SMPFunction* func, STARS_ea_t TargetAddr)
	{ return false; } 


	// see src/ file.
	virtual bool AnalyzeInstAsCallTarget(SMPFunction *CurrFunc, 
				bool &IsIndirectCallTarget, 
			bool &IsTailCallTarget) ;

	// see src/ dir.
	virtual bool IsInstIDInFunc(STARS_ea_t InstID);


private:
	libIRDB::Function_t* the_func;
	libIRDB::FileIR_t* firp;

	// disallow access to class members.
	static void IRDB_IR_Build_helper
				(
						SMPFunction *func,
						SMPInstr *CurrInst
				);


};

#endif
